<?php defined('SYSPATH') or die('No direct script access.');

class Model_Rating extends Model
{
    public static function GetStudentsForRating($discipline) {
        $sql = "CALL `GetStudentsForRating`(:discipline)";
        return DB::query(Database::SELECT, $sql)
            ->param(':discipline', $discipline)
            ->execute();
    }

    /**
     * Get the disciplines's roadmap (учебная карта).
     * @param $discipline int discipline id
     * @return Database_Result select from <tt>view_roadmap</tt> table
     */
    public static function getMapForDiscipline($discipline) {
        $sql = "CALL `GetRoadmap`(:discipline)";
        return DB::query(Database::SELECT, $sql)
            ->param(':discipline', $discipline)
            ->execute();
    }

    /**
     * @param $discipline int discipline id
     * @param $student    int student id
     * @return Database_Result
     */
    public static function getRates($discipline, $student) {
        $sql = "CALL `GetRates`(:student, :discipline)";
        return DB::query(Database::SELECT, $sql)
            ->param(':discipline', $discipline)
            ->param(':student', $student)
            ->execute();
    }

    /**
     * @param $discipline int discipline id
     * @param $student    int student id
     * @return Database_Result
     */
    public static function getExamRates($discipline, $student) {
        $sql = "CALL `GetRatesExam`(:student, :discipline)";
        return DB::query(Database::SELECT, $sql)
            ->param(':discipline', $discipline)
            ->param(':student', $student)
            ->execute();
    }

    public static function GetMapForDisciplineExam($discipline) {
        $sql = "CALL `GetRoadmapExam`(:discipline)";
        return DB::query(Database::SELECT, $sql)
            ->param(':discipline', $discipline)
            ->execute();
    }

    public static function getMapForStudent($student, $discipline) {
        $sql = "CALL `GetMapForStudent`(:student, :discipline)";
        return DB::query(Database::SELECT, $sql)
            ->param(':discipline', $discipline)
            ->param(':student', $student)
            ->execute();
    }

    public static function getAttestationData($discipline, $group) {
        $sql = "CALL `GetAttestationData`(:discipline, :group)";
        return DB::query(Database::SELECT, $sql)
            ->param(':discipline', $discipline)
            ->param(':group', $group)
            ->execute();
    }

    public static function SetStudentRate($teacher, $student, $submodule, $rate) {
        if ($rate == -1) $rate = null;  # fixme: kind of shit

        $sql = "SELECT `SetStudentRate`(:teacher, :student, :submodule, :rate) AS `Num`";
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':teacher'   => $teacher,
                ':student'   => $student,
                ':submodule' => $submodule,
                ':rate'      => (int) $rate
            ])->execute();
    }

    public static function getRatesForStudentsGroup($discipline, $group) {
        $sql = "CALL `GetRatesForGroup`(:discipline, :group)";
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':discipline' => $discipline,
                ':group'      => $group,
            ])->execute();
    }

    public static function getRatesForStudentsGroupByStage($discipline, $group, $stage) {
        $sql = "CALL `GetRatesForGroupByStage`(:discipline, :group, :stage)";
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':discipline' => $discipline,
                ':group'      => $group,
                ':stage'      => $stage
            ])->execute();
    }

    public static function getFinalFormInfo($discipline, $group) {
        $sql = "CALL `getFinalFormInfo`(:discipline, :group)";
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':discipline' => $discipline,
                ':group'      => $group,
            ])->execute();
    }

    /**
     * Get count of related with discipline records in `rating_table`.
     * @param Model_Discipline $discipline
     * @return int
     */
    public static function count(Model_Discipline $discipline) {
        $sql = "SELECT `Discipline_CountRatings`(:discipline) AS `res`";
        $res = DB::query(Database::SELECT, $sql)
            ->param(':discipline', $discipline->ID)
            ->execute();

        return (int) $res->get('res');
    }

    public static function setExamPeriodOption($student, $submodule, $option) {
        // option is absence or pass or null
        $sql = "SELECT `SetExamPeriodOption`(:student, :submodule, :option) As `ErrorCode`";
        return DB::query(Database::SELECT, $sql)
            ->parameters([
                ':student'   => $student,
                ':submodule' => $submodule,
                ':option'    => $option
            ])->execute()[0];
    }
}
